@import "../../static/css/mixins";

@mixin editable-field-focus() {
  &.isFocus {
    --focus-border-color: #{$color-grey-border};
  }
}

.table-panel-inner {
  &::v-deep {
    mark {
      color: $style-white;
      background: $cssTableStyle_table_panel_inner_mark_background;
    }

    .missing-property {
      color: red;
      font-size: 12px;
      height: 100%;
      display: flex;
      align-items: center;
    }
  }
  &_isLoading {
    height: 100%;
  }
}

.ob-table-inner {
  position: relative;
  height: 100%;
  display: flex;
  flex-direction: column;

  &_isLoading {
    min-height: 120px;
  }

  &__loader {
    &-row {
      position: absolute;
      z-index: 999;
      display: flex;
      background: $cssTableStyle_loader_row_background;
      top: 0;
      left: 0;
      justify-content: center;
      width: 100%;
      height: 100%;
      min-height: 120px;
      padding: 20px 0 20px 0;
    }

    &-column {
      display: flex;
      flex-direction: column;
      margin-top: 120px;
      min-height: 120px;
      height: 100%;
    }
  }

  &.--fixed-header {
    height: 0;
    flex-grow: 1;
  }

  &.--with-data {
    .table-panel-inner {
      flex-grow: 2;
    }
  }

  &.--with-pagination {
    .table-footer {
      height: 40px;
    }
  }

  .ob-func-panel, .table-header {
    transition: opacity 1s;
  }

  &.--only-body {
    .ob-func-panel, .table-header {
      opacity: 0;
    }
  }

  &.tb_showMore {
    &:before {
      content: '';
      position: absolute;
      right: 0;
      top: 0;
      bottom: 0;
      width: 30px;
      background: -moz-linear-gradient(0deg, $obTable-showMore_gradient_start 0%, $obTable-showMore_gradient_end 100%); /* ff3.6+ */
      background: -webkit-gradient(linear, left top, right top, color-stop(0%, $obTable-showMore_gradient_start), color-stop(100%, $obTable-showMore_gradient_end)); /* safari4+,chrome */
      background: -webkit-linear-gradient(0deg, $obTable-showMore_gradient_start 0%, $obTable-showMore_gradient_end 100%); /* safari5.1+,chrome10+ */
      background: -o-linear-gradient(0deg, $obTable-showMore_gradient_start 0%, $obTable-showMore_gradient_end 100%); /* opera 11.10+ */
      background: -ms-linear-gradient(0deg, $obTable-showMore_gradient_start 0%, $obTable-showMore_gradient_end 100%); /* ie10+ */
      background: linear-gradient(90deg, $obTable-showMore_gradient_start 0%, $obTable-showMore_gradient_end 100%); /* w3c */
      filter: progid:DXImageTransform.Microsoft.gradient(startColorstr=$obTable-showMore_ms_gradient_start, endColorstr=$obTable-showMore_ms_gradient_end, GradientType=1); /* ie6-9 */
      z-index: 100;
    }

    &.tb_footer:before {
      bottom: 40px;
    }

    &.th_header:before {
      top: 60px;
    }

    &.tb_footer.th_header:before {
      top: 60px;
      bottom: 40px;
    }
  }
  tr.isEdit:not(:first-child):hover,
  tr.row-selected.isEdit {
    //background: #a9a9a9;
  }

  @mixin highlight-field () {
    &.isError {
      --focus-border-color: #{$light-raspberry-red};
    }

    &.isWarning {
      --focus-border-color: #{$diamond-orange-yellow};
    }
  }

  .obInputField::v-deep {
    @include highlight-field;
    @include editable-field-focus;

    min-width: 100px;
    margin-left: -13px;

    &.isWide {
      width: 100%;
    }

    .ob-input-wrap {
      height: 30px;
      border-radius: 3px;
      padding: 7px 12px 3px;
      box-sizing: border-box;
      border: 1px solid var(--focus-border-color);
      background-color: $background-white;

      &:hover {
        border-color: $blue-300;
      }

      &.--focused {
        border-color: $color-blue-navy-blue;
        box-shadow: inset 0 3px 6px rgba(25, 30, 50, .1);
        .units {
          opacity: 1;
        }
      }

      &:focus {
        outline: none;
        .units {
          opacity: 1;
        }
      }

      &.--readonly {
        background-color: $color-white-lilac;
        border-color: $color-white-lilac;
      }

      .input-group .input {
        @include font-mixin(14px, 20px, 400, $color-text-base);

        text-overflow: ellipsis;
      }

      .units {
        @include font-mixin(14px, 18px, 400, $color-text-base);
        opacity: 0.6;
      }
    }
  }

  .obDatepickerField::v-deep {
    max-width: 118px;

    &.withTime {
      max-width: 161px;
    }

    .ob-input-wrap {
      padding: 7px 7px 3px 12px;
    }

    .main-icon {
      margin-left: 10px;

      i {
        position: relative;
        top: -2px;
        font-size: 14px;
      }
    }
  }

  .obCheckboxField {
    margin-left: -5px;
  }

  .obSelectField::v-deep {
    @include highlight-field;
    @include editable-field-focus;

    $this: '.ob-selector';

    margin-left: -11px;
    background-color: $background-white;

    .ob-selector {
      &__select,
      &__dropdown.compact {
        min-height: 30px;
        transition: border .1s linear;

        &:focus {
          outline: none;
        }
      }

      :not(.disabled) &__select,
      :not(.disabled) &__dropdown.compact {
          background-color: transparent;
          border-color: var(--focus-border-color);

          &:hover {
            border-color: $blue-300;
          }

          &:active,
          &:focus,
          &_open {
            border-color: $blue-700 !important;

            #{$this}__value,
            #{$this}__controls .icon {
              color: $blue-700;
            }
          }
        }

      &__title {
        padding: 5px 7px 3px 10px;
      }

      &__value {
        @include font-mixin(14px, 20px, 400, $color-blue-navy-blue);

        margin-left: 0;

        &.is-placeholder {
          color: $gray-window;
        }
      }

      &__controls .icon {
        width: 12px;
        height: 12px;
        font-size: 12px;
        color: $color-blue-navy-blue;
      }
    }

    &.disabled {
      #{$this} {
        &__select {
          border-color: transparent !important;
        }

        &__value {
          color: $color-grey-span;
        }
      }
    }
  }

  .isEdit {
    background: $cssTableStyle_ob_table_inner_isEdit_background;
  }

  .none-data-slot {
    position: absolute;
    z-index: 1;
    top: 0;
    bottom: 0;
    left: 0;
    width: 100%;
    display: flex;
    flex-direction: column;
    justify-content: center;
    align-items: center;
    text-align: center;
    background-color: $background-white;
    font-size: 16px;
    line-height: 20px;
    color: $color-text-base;
    letter-spacing: 0.4px;

    &.--with-func-panel {
      top: 60px;
    }

    &::v-deep {
      & > div {
        transform: translateY(-50px);
      }
      .title {
        margin-bottom: 20px;
        font-size: 24px;
        line-height: 29px;
        color: $color-grey-span;
        letter-spacing: 0.4px;
      }
      a {
        color: $color-blue-navy-blue;
      }
    }
  }

  .sub-table-body {
    .none-data-slot {
      &::v-deep {
        & > div {
          transform: none;
        }
      }
    }
  }
}

.none-content-title {
  margin-bottom: 20px;
  font-size: 18px;
  line-height: 29px;
  color: $color-grey-span;
  letter-spacing: 0.4px;
}

.sub-table-body {
  .none-content-title {
    margin-bottom: 0;
  }
}

table {
  border-collapse: collapse;
  width: 100%;
  min-width: 1100px;

  &.table-data {
    table-layout: auto;
  }

  &.table-header.fixed {
    z-index: 10;
    background-color: $background-white;
    position: absolute;
  }

  tbody {
    &.--closed {
      .groups-row {
        display: none;
      }
    }
  }

  .groups-header {
    $this: &;

    display: flex;
    justify-content: flex-start;
    align-items: center;
    height: 40px;
    padding: 10px 14px;
    background-color: $light-lavender;
    cursor: pointer;

    &__checkbox {
      margin-right: 18px;
    }

    &__arrow-toggle {
      margin-right: 15px;
      transform: translateY(-1px);
      font-size: 22px;
      color: $color-blue-navy-blue;
    }

    &__title {
      font-family: Roboto, sans-serif;
      font-style: normal;
      font-weight: normal;
      font-size: 14px;
      line-height: 20px;
      letter-spacing: 0.2px;
      color: $color-blue-navy-blue;
    }

    &.--sticky {
      #{$this}__arrow-toggle {
        position: sticky;
        left: 14px;
      }

      #{$this}__title {
        position: sticky;
        left: 51px;
      }
    }
  }

  .sub-table-header {
    $this: &;

    td {
      background-color: $light-lavender;
      cursor: pointer;
    }

    &__checkbox {
      margin-right: 18px;
    }

    &__arrow-toggle {
      margin-right: 15px;
      transform: translateY(-1px);
      font-size: 22px;
      color: $color-blue-navy-blue;
    }

    &__title {
      font-family: Roboto, sans-serif;
      font-style: normal;
      font-weight: normal;
      font-size: 14px;
      line-height: 20px;
      letter-spacing: 0.2px;
      color: $color-blue-navy-blue;
    }

    &.--sticky {
      #{$this}__arrow-toggle {
        position: sticky;
        left: 14px;
      }

      #{$this}__title {
        position: sticky;
        left: 51px;
      }
    }
  }
}

// In modals we don't need to set 'min-width',
// because often modals is smaller than 1100px in width,
// and extra scroll is uncomfortable to use
.modal table {
  min-width: auto;
}

tr {
  --focus-border-color: transparent;

  border-top: 1px solid $lavender;
  border-bottom: 1px solid $lavender;

  &:not(:first-child):hover {
    background: $light-lavender;
    td {
      &.--sticky {
        background: $light-lavender;
        &.--sticky-column-last {
          background: linear-gradient(-90deg, $cssTableStyle_gradient_color_1 0px, $cssTableStyle_gradient_color_2 4px, $light-lavender 4px, $light-lavender 100%);
        }
      }
    }
  }

  &.row-selected {
    $selected-row-background: rgba($blue-100, .5);

    background-color: $selected-row-background;

    &:hover {
      background-color: $selected-row-background;
    }
  }

  &.clickable {
    cursor: pointer;
  }

  &:hover ::v-deep {
    --focus-border-color: #{$color-grey-border};
  }
}

td {
  position: relative;
  height: 100%;

  &.--drag-hovered {
    &::after {
      content: '';
      display: block;
      width: 100%;
      height: 100%;
      position: absolute;
      z-index: 5000;
      top: 0;
      left: 0;
      background-color: $color-blue-navy-blue;
      opacity: 0.1;
    }
  }
}

td, th {
  padding: 0;

  > .td-container {
    min-height: 40px;
    padding: 8px 14px;
    box-sizing: border-box;
    font-family: "Roboto", sans-serif;
    font-size: 14px;
    line-height: 20px;
    letter-spacing: 0.2px;
    color: $color-text-base;
  }

  &:first-child > .td-container {
    padding-left: 18px;
  }

  &:last-child > .td-container {
    padding-right: 18px;
  }
  &.--sticky {
    position: sticky;
    //background: $background-white;
    &.--sticky-column-last {
      background: linear-gradient(-90deg, $cssTableStyle_gradient_color_1 0px, $cssTableStyle_gradient_color_2 4px, $background-white 4px, $background-white 100%);
    }
  }

  &.--disabled {
    background-color: rgba($color-white-lilac, 0.6);
  }
}
th {
  &:hover {
    background: $cssTableStyle_th_background_hover;
  }

  & > .td-container {
    font-family: "Roboto", sans-serif;
    font-size: 11px;
    line-height: 15px;
    font-weight: 400;
    text-align: left;
    display: flex;
    align-items: center;
    letter-spacing: 0.4px;
    text-transform: uppercase;
    color: $shale-gray;
    cursor: pointer;
  }

  &.--sort-disable {
    & > .td-container {
      cursor: default;
    }
  }
}

.td-container {
  display: flex;
  align-items: center;

  &.align-right {
    justify-content: flex-end;
  }
}

.table-panel-inner {
  background: $background-white;
  overflow: auto;
  position: relative;
  height: 100%;
}

.table-footer {
  position: relative;
  display: flex;
  align-items: center;
  justify-content: space-between;
  height: 30px;
  padding: 0 15px;
  text-transform: uppercase;
  font-family: "Roboto", sans-serif;
  font-size: 12px;
  line-height: 16px;
  letter-spacing: .4px;
  border-top: 1px $lavender solid;
  border-bottom: 1px solid transparent;
  color: $shale-gray;
  background: $background-color-light;

  &:before {
    content: '';
    position: absolute;
    top: -4px;
    left: 0;
    display: block;
    width: 100%;
    height: 4px;
    background: linear-gradient(180deg, $cssTableStyle_footer_gradient_color_1_before 0%, $cssTableStyle_footer_gradient_color_2_before 100%);
    opacity: 0.4;
  }
}

.total-count {
  flex-shrink: 0;
  margin-right: 20px;
}

.table-empty {
  display: flex;
  flex-direction: column;
  align-items: center;
  justify-content: center;
  flex-grow: 2;
  min-height: 300px;
  text-align: center;
  text-transform: uppercase;
  font-family: "Roboto", sans-serif;
  color: $cssTableStyle_table-empty_color;
  font-weight: 900;
}

.sub-table-body {
  .table-empty {
    min-height: 80px;
  }
}

.sort-direction {
  display: flex;
  justify-content: center;
  align-items: center;
  margin-left: 8px;
  font-size: 14px;
  line-height: 15px;
  color: $style-black;

  .icon::before {
    color: $color-grey-span;
  }

  &.--revert {
    transform: rotate(180deg) translateY(1px);
  }
}

.title-info-icon {
  cursor: default;
  position: relative;
  top: 1px;
  font-size: 12px;
  font-weight: bold;
  color: $color-blue-navy-blue;
}

.row-checkbox {
  &.with-margin {
    margin-left: 37px;
  }
}

.has-action {

  &:hover {
    background-color: #ffffff !important;
  }
}

.groupAction {
  display: inline-flex;
  align-items: center;
  padding: 11px 14px;
  color: $color-blue-smalt;
  cursor: pointer;

  .icon {
    margin-right: 5px;
    color: $color-grey-span;
  }
}

.subTableAction {
  display: inline-flex;
  align-items: center;
  padding: 11px 14px;
  color: $color-blue-smalt;
  cursor: pointer;

  .icon {
    margin-right: 5px;
    color: $color-grey-span;
  }
}

.--closed .groupAction {
  display: none;
}
